<?php
/**
 * 
 * @copyright	2000-2007 LOCKON CO.,LTD. All Rights Reserved.
 * @link		http://www.lockon.co.jp/
 *
 */
require_once(DATA_PATH . "module/Request.php");
require_once(DATA_PATH . "lib/slib.php");

define('COMBZ_ENCODE', 'Shift-JIS');

/****  *********************************************************************************************/

define("MDL_COMBZ_ID", 13);
define("MODULE_NAME", "ӡϢư⥸塼");
define("MODULE_ID", MDL_COMBZ_ID);

/**************************************************************************************************************
 * ؿ̾	sfCombzSetModuleDB
 * 	ɬפʥǡ롣
 * 1	
 * 2	
 * 3	
 * 	
 **************************************************************************************************************/
function sfCombzSetModuleDB($module_id, $objFormParam){
    global $objQuery;
    $arrRet = $objFormParam->getHashArray();
    foreach($arrRet as $key => $val) {
    	$arrVal[$key] = $val;
    }    
	$sqlval['sub_data'] = serialize($arrVal);	
    $objQuery->update("dtb_module", $sqlval, "module_id = ?", array($module_id));
}

/**************************************************************************************************************
 * ؿ̾	sfCombzGetModuleDB
 * 	ɬפʥǡ롣
 * 1	
 * 2	
 * 3	
 * 	
 **************************************************************************************************************/
// DBǡ
function sfCombzGetModuleDB($module_id){
   	$objQuery = new SC_Query();
    $arrVal = array($module_id);
    $arrRet = array();
    $sql = "SELECT 
                sub_data
            FROM dtb_module WHERE module_id = ? " . $where;
    $arrRet = $objQuery->getall($sql, $arrVal);
    return unserialize($arrRet[0]['sub_data']);
}
/**************************************************************************************************************
 * ؿ̾	sfCombzReserve
 * 	
 * 1	
 * 2	
 * 3	
 * 	
 **************************************************************************************************************/
function sfCombzReserve($where, $arrval) {
	ini_set("mbstring.http_input", COMBZ_ENCODE);
	ini_set("mbstring.http_output", COMBZ_ENCODE);
	ini_set("default_charset", COMBZ_ENCODE);
	ini_set("mbstring.internal_encoding", COMBZ_ENCODE);
	
	//ǡ
 	$arrForm = sfCombzGetModuleDB(MODULE_ID);
	//ڡ饹
	class LC_ReservePage {
		//󥹥ȥ饯
		function LC_ReservePage() {
			//ᥤƥץ졼Ȥλ
			$this->tpl_mainpage = MODULE_PATH . 'mdl_combz/combz_reserve.tpl';
		}
	}
	
	$objPage = new LC_ReservePage();
	$objView = new SC_AdminView();
	$objQuery = new SC_Query();
	
	$objPage->arrForm = $arrForm;
	$objView->assignobj($objPage);						//ѿƥץ졼Ȥ˥󤹤
	$fetch = $objView->fetch($objPage->tpl_mainpage);	//ƥץ졼Ȥν
	$fetch = mb_convert_encoding($fetch, COMBZ_ENCODE);
	print($fetch);
}

/**************************************************************************************************************
 * ؿ̾	sfCombzRegist
 * 	
 * 1	
 * 2	
 * 3	
 * 	
 **************************************************************************************************************/
function sfCombzRegist($where, $arrval) {
	ini_set("mbstring.http_input", COMBZ_ENCODE);
	ini_set("mbstring.http_output", COMBZ_ENCODE);
	ini_set("default_charset", COMBZ_ENCODE);
	ini_set("mbstring.internal_encoding", COMBZ_ENCODE);
		
	//ǡ
 	$arrForm = sfCombzGetModuleDB(MODULE_ID);
	
	//ڡ饹
	class LC_ReservePage {
		//󥹥ȥ饯
		function LC_ReservePage() {
			//ᥤƥץ졼Ȥλ
			$this->tpl_mainpage = MODULE_PATH . 'mdl_combz/combz_regist.tpl';
		}
	}
	
	$objPage = new LC_ReservePage();
	$objView = new SC_AdminView();
	
	$objQuery = new SC_Query();
	$arrRet = $objQuery->select("email, email_mobile", "dtb_customer", $where, $arrval);
	$arrForm['set_data'] = "";
	for($i = 0; $i < count($arrRet); $i++) {
		if($arrRet[$i]['email'] != "") {
			$arrForm['set_data'].= 	$arrRet[$i]['email'] . "\n";
		}
		if($arrRet[$i]['email_mobile'] != "" && $arrRet[$i]['email'] != $arrRet[$i]['email_mobile']) {
			$arrForm['set_data'].= 	$arrRet[$i]['email_mobile'] . "\n";	
		}
	}
		
	$objPage->arrForm = $arrForm;
	$objView->assignobj($objPage);						//ѿƥץ졼Ȥ˥󤹤
	$fetch = $objView->fetch($objPage->tpl_mainpage);	//ƥץ졼Ȥν
	$fetch = mb_convert_encoding($fetch, COMBZ_ENCODE);
	print($fetch);
	
}

/**************************************************************************************************************
 * ؿ̾	sfCombzPost
 * 	
 * 1	
 * 2	
 * 3	
 * 	
 **************************************************************************************************************/
function sfCombzPost($combz_type, $where, $arrval) {
	switch($combz_type) {
	case 'reserve':
		sfCombzReserve($where, $arrval);
		break;
	case 'regist':
		sfCombzRegist($where, $arrval);
		break;
	default:
		print("ӡϢȡͤǤ");
		break;	
	}
	exit;
}