<?php
/*
 * Copyright(c) 2000-2007 LOCKON CO.,LTD. All Rights Reserved.
 *
 * http://www.lockon.co.jp/
 */
require_once(MODULE_PATH . "mdl_paygent/mdl_paygent.inc");

class LC_Page {
	function LC_Page() {
		/** ɬꤹ **/
		if (GC_MobileUserAgent::isMobile()) {
			$this->tpl_mainpage = MODULE_PATH . "mdl_paygent/paygent_bank_mobile.tpl";
		} else {
			$this->tpl_mainpage = MODULE_PATH . "mdl_paygent/paygent_bank.tpl";
		}
		/*
		 session_startno-cacheإå뤳Ȥ
		 ץܥѻͭڤɽ롣
		 private-no-expire:饤ȤΥåĤ롣
		*/
		session_cache_limiter('private-no-expire');		
	}
}

$objPage = new LC_Page();
if (GC_MobileUserAgent::isMobile()) {
	$objView = new SC_MobileView();
} else {
	$objView = new SC_SiteView();
}
$objCampaignSess = new SC_CampaignSession();
$objCustomer = new SC_Customer();
$objSiteInfo = $objView->objSiteInfo;
$arrInfo = $objSiteInfo->data;

// ѥ᡼饹
$objFormParam = new SC_FormParam();

// ơ֥ɹ
$arrData = sfGetOrderTemp($uniqid);

// ѥ᡼ν
lfInitParam($arrData);
// POSTͤμ
$objFormParam->setParam($_POST);

// Ƚ׽
$objPage = sfTotalCart($objPage, $objCartSess, $arrInfo);

// ơ֥ɹ
$arrData = sfGetOrderTemp($uniqid);

// Ƚפ򸵤˺ǽ׻
$arrData = sfTotalConfirm($arrData, $objPage, $objCartSess, $arrInfo);

switch($_POST['mode']) {
// Υڡ
case 'return':
	// ʿܤǤ뤳ȤϿƤ
	$objSiteSess->setRegistFlag();
	if (GC_MobileUserAgent::isMobile()) {
		header("Location: " . gfAddSessionId(MOBILE_URL_SHOP_CONFIRM));
	} else {
		header("Location: " . URL_SHOP_CONFIRM);
	}
	break;
// 
case 'next':
	// ͤѴ
	$objFormParam->convParam();
	$objPage->arrErr = lfCheckError($arrRet);
	// ϥ顼ʤξ
	if(count($objPage->arrErr) == 0) {
		// ϥǡμԤ
    	$arrInput = $objFormParam->getHashArray();
		// 쥸åʸ
		$arrRet = sfSendPaygentBANK($arrData, $arrInput, $uniqid);
		
		// 
		if(strlen($arrRet['asp_url']) > 0) {
            // Ͽ줿ȤϿƤ
			$objSiteSess->setRegistFlag();
			// Ͽ
			$objQuery->begin();
			$order_id = lfDoComplete($objQuery, $uniqid);
			$objQuery->commit();
			// åݴɤƤ򹹿
			$objCustomer->updateSession();
			// λ᡼
			if($order_id != "") {
				$order_email = $objQuery->select("order_email", "dtb_order", "order_id = ?", array($order_id));
			    //ϿƤ᡼륢ɥ쥹ӤPC˱ʸλ᡼Υƥץ졼ȤѤ
			    if(ereg("(ezweb.ne.jp$|docomo.ne.jp$|softbank.ne.jp$|vodafone.ne.jp$)",$order_email[0]['order_email'])){
		            // Х
		    		sfSendOrderMail($order_id, '2');
		        }else{
					// PC
		        	sfSendOrderMail($order_id, '1');
		        }
			}
			// ڥȷѲ̤
			header("Location: " . $arrRet['asp_url']);
		// 
		} else {
			$objPage->tpl_error = "ǧڤ˼ԤޤǤƤ򤴳ǧ";
		}
	}
	break;
}

$objDate = new SC_Date();
$objDate->setStartYear(RELEASE_YEAR);
$objDate->setEndYear(RELEASE_YEAR + CREDIT_ADD_YEAR);
$objPage->arrYear = $objDate->getZeroYear();
$objPage->arrMonth = $objDate->getZeroMonth();

// ̤ɽ
$objPage = sfPaygentDisp($objPage, $payment_id);

$objPage->arrNetBank = $arrNetBank;
$objPage->arrForm = $objFormParam->getFormParamList();
$objView->assignobj($objPage);
// ե졼(ڡڡܤʤѹ)
$objCampaignSess->pageView($objView);

//-----------------------------------------------------------------------------------------------

/* ѥ᡼ν */
function lfInitParam($arrData) {
	global $objFormParam;
	$objFormParam->addParam("Ѽ", "customer_family_name", PAYGENT_BANK_STEXT_LEN / 2, "KVa", array("EXIST_CHECK", "MAX_LENGTH_CHECK"), $arrData['order_name01']);
	$objFormParam->addParam("Ѽ̾", "customer_name", PAYGENT_BANK_STEXT_LEN / 2, "KVa", array("EXIST_CHECK", "MAX_LENGTH_CHECK"), $arrData['order_name02']);
	$objFormParam->addParam("Ѽ", "customer_family_name_kana", PAYGENT_BANK_STEXT_LEN, "CKVa", array("EXIST_CHECK", "KANA_CHECK", "MAX_LENGTH_CHECK"), $arrData['order_kana01']);
	$objFormParam->addParam("Ѽ̾", "customer_name_kana", PAYGENT_BANK_STEXT_LEN, "CKVa", array("EXIST_CHECK", "KANA_CHECK", "MAX_LENGTH_CHECK"), $arrData['order_kana02']);
}

/* ƤΥå */
function lfCheckError() {
	global $objFormParam;
	// ϥǡϤ
	$arrRet =  $objFormParam->getHashArray();
	$objErr = new SC_CheckError($arrRet);
	$objErr->arrErr = $objFormParam->checkError();
	
	return $objErr->arrErr;
}

// λ
function lfDoComplete($objQuery, $uniqid) {
	global $objCartSess;
	global $objSiteSess;
	global $objCampaignSess;
	global $objCustomer;
	global $arrInfo;
	
	// ơ֥ɹ
	$arrData = sfGetOrderTemp($uniqid);

	// Ͽ
	if ($objCustomer->isLoginSuccess()) {
		// ϤϿ
		lfSetNewAddr($uniqid, $objCustomer->getValue('customer_id'));
		// פܵҥơ֥ȿ
		lfSetCustomerPurchase($objCustomer->getValue('customer_id'), $arrData, $objQuery);
	} else {
		//Ͽ
		switch(PURCHASE_CUSTOMER_REGIST) {
		//̵
		case '0':
			// Ͽ
			if($arrData['member_check'] == '1') {
				// Ͽ
				$customer_id = lfRegistPreCustomer($arrData, $arrInfo);
				// פܵҥơ֥ȿ
				lfSetCustomerPurchase($customer_id, $arrData, $objQuery);
			}
			break;
		//ͭ
		case '1':
			// Ͽ
			$customer_id = lfRegistPreCustomer($arrData, $arrInfo);
			// פܵҥơ֥ȿ
			lfSetCustomerPurchase($customer_id, $arrData, $objQuery);
			break;
		}
	}
	
	// ơ֥ơ֥˳Ǽ
	$order_id = lfRegistOrder($objQuery, $arrData, $objCampaignSess);
	// Ⱦʤܺ٥ơ֥˳Ǽ
	lfRegistOrderDetail($objQuery, $order_id, $objCartSess);
	// ơ֥ξ롣
	lfDeleteTempOrder($objQuery, $uniqid);
	// ڡ󤫤ܤξϿ롣
	if($objCampaignSess->getIsCampaign() and $objCartSess->chkCampaign($objCampaignSess->getCampaignId())) {
		lfRegistCampaignOrder($objQuery, $objCampaignSess, $order_id);
	}
	
	// å󥫡ξʤ롣
	$objCartSess->delAllProducts();
	// ʸID롣
	$objSiteSess->unsetUniqId();
	
	return $order_id;
}

// ơ֥ν꤬ϿѤߥơ֥Ȱۤʤϡ̤ΤϤɲä
function lfSetNewAddr($uniqid, $customer_id) {
	$objQuery = new SC_Query();
	$diff = false;
	$find_same = false;
	
	$col = "deliv_name01,deliv_name02,deliv_kana01,deliv_kana02,deliv_tel01,deliv_tel02,deliv_tel03,deliv_zip01,deliv_zip02,deliv_pref,deliv_addr01,deliv_addr02";
	$where = "order_temp_id = ?";
	$arrRet = $objQuery->select($col, "dtb_order_temp", $where, array($uniqid));
	
	// ̾deliv_롣
	foreach($arrRet[0] as $key => $val) {
		$keyname = ereg_replace("^deliv_", "", $key);
		$arrNew[$keyname] = $val;
	}
	
	// ơ֥Ȥ
	$col = "name01,name02,kana01,kana02,tel01,tel02,tel03,zip01,zip02,pref,addr01,addr02";
	$where = "customer_id = ?";
	$arrCustomerAddr = $objQuery->select($col, "dtb_customer", $where, array($customer_id));
	
	// νȰۤʤ
	if($arrNew != $arrCustomerAddr[0]) {
		// ̤ΤϤơ֥νӤ
		$col = "name01,name02,kana01,kana02,tel01,tel02,tel03,zip01,zip02,pref,addr01,addr02";
		$where = "customer_id = ?";
		$arrOtherAddr = $objQuery->select($col, "dtb_other_deliv", $where, array($customer_id));

		foreach($arrOtherAddr as $arrval) {
			if($arrNew == $arrval) {
				// ǤƱ꤬ϿƤ
				$find_same = true;
			}
		}
		
		if(!$find_same) {
			$diff = true;
		}
	}
	
	// Ϥ褬ϿѤߤΤΤȰۤʤ̤ΤϤơ֥Ͽ
	if($diff) {
		$sqlval = $arrNew;
		$sqlval['customer_id'] = $customer_id;
		$objQuery->insert("dtb_other_deliv", $sqlval);
	}
}

/* ơ֥Ͽ */
function lfSetCustomerPurchase($customer_id, $arrData, $objQuery) {
	$col = "first_buy_date, last_buy_date, buy_times, buy_total, point";
	$where = "customer_id = ?";
	$arrRet = $objQuery->select($col, "dtb_customer", $where, array($customer_id));
	$sqlval = $arrRet[0];
	
	if($sqlval['first_buy_date'] == "") {
		$sqlval['first_buy_date'] = "Now()";
	}
	$sqlval['last_buy_date'] = "Now()";
	$sqlval['buy_times']++;
	$sqlval['buy_total']+= $arrData['total'];
	$sqlval['point'] = ($sqlval['point'] + $arrData['add_point'] - $arrData['use_point']);
	
	// ݥȤ­Ƥ
	if($sqlval['point'] < 0) {
		$objQuery->rollback();
		sfDispSiteError(LACK_POINT);
	}
	
	$objQuery->update("dtb_customer", $sqlval, $where, array($customer_id));
}

// ϿʲϿ
function lfRegistPreCustomer($arrData, $arrInfo) {
	// βϿ
	$sqlval['name01'] = $arrData['order_name01'];
	$sqlval['name02'] = $arrData['order_name02'];
	$sqlval['kana01'] = $arrData['order_kana01'];
	$sqlval['kana02'] = $arrData['order_kana02'];
	$sqlval['zip01'] = $arrData['order_zip01'];
	$sqlval['zip02'] = $arrData['order_zip02'];
	$sqlval['pref'] = $arrData['order_pref'];
	$sqlval['addr01'] = $arrData['order_addr01'];
	$sqlval['addr02'] = $arrData['order_addr02'];
	$sqlval['email'] = $arrData['order_email'];
	$sqlval['tel01'] = $arrData['order_tel01'];
	$sqlval['tel02'] = $arrData['order_tel02'];
	$sqlval['tel03'] = $arrData['order_tel03'];
	$sqlval['fax01'] = $arrData['order_fax01'];
	$sqlval['fax02'] = $arrData['order_fax02'];
	$sqlval['fax03'] = $arrData['order_fax03'];
	$sqlval['sex'] = $arrData['order_sex'];
	$sqlval['password'] = $arrData['password'];
	$sqlval['reminder'] = $arrData['reminder'];
	$sqlval['reminder_answer'] = $arrData['reminder_answer'];
	
	// ޥۿѥե饰Ƚ
	switch($arrData['mail_flag']) {
	case '1':	// HTML᡼
		$mail_flag = 4;
		break;
	case '2':	// TEXT᡼
		$mail_flag = 5;
		break;
	case '3':	// ˾ʤ
		$mail_flag = 6;
		break;
	default:
		$mail_flag = 6;
		break;
	}
	// ޥե饰
	$sqlval['mailmaga_flg'] = $mail_flag;
		
	// Ͽ
	$sqlval['status'] = 1;
	// URLȽѥ
	$sqlval['secret_key'] = sfGetUniqRandomId("t"); 
	
	$objQuery = new SC_Query();
	$sqlval['create_date'] = "now()";
	$sqlval['update_date'] = "now()";
	$objQuery->insert("dtb_customer", $sqlval);
	
	// ܵIDμ
	$arrRet = $objQuery->select("customer_id", "dtb_customer", "secret_key = ?", array($sqlval['secret_key']));
	$customer_id = $arrRet[0]['customer_id'];
	
	//Ͽλ᡼
	$objMailPage = new LC_Page();
	$objMailPage->to_name01 = $arrData['order_name01'];
	$objMailPage->to_name02 = $arrData['order_name02'];
	$objMailPage->CONF = $arrInfo;
	$objMailPage->uniqid = $sqlval['secret_key'];
	$objMailView = new SC_SiteView();
	$objMailView->assignobj($objMailPage);
	$body = $objMailView->fetch("mail_templates/customer_mail.tpl");
	
	$objMail = new GC_SendMail();
	$objMail->setItem(
						''										//
						, sfMakeSubject("ϿΤǧ")		//֥
						, $body									//ʸ
						, $arrInfo['email03']					//ɥ쥹
						, $arrInfo['shop_name']					//̾
						, $arrInfo["email03"]					//reply_to
						, $arrInfo["email04"]					//return_path
						, $arrInfo["email04"]					//  Errors_to
						, $arrInfo["email01"]					//  Bcc
														);
	// 
	$name = $arrData['order_name01'] . $arrData['order_name02'] ." ";
	$objMail->setTo($arrData['order_email'], $name);			
	$objMail->sendMail();
	
	return $customer_id;
}

// ơ֥Ͽ
function lfRegistOrder($objQuery, $arrData, $objCampaignSess) {
	$sqlval = $arrData;

	// ơ֥˽񤭹ޤʤ
	unset($sqlval['mailmaga_flg']);		// ޥå
	unset($sqlval['deliv_check']);		// ̤ΤϤå
	unset($sqlval['point_check']);		// ݥѥå
	unset($sqlval['member_check']);		// å
	unset($sqlval['password']);			// ѥ
	unset($sqlval['reminder']);			// ޥ
	unset($sqlval['reminder_answer']);	// ޥ
	unset($sqlval['mail_flag']);		// ᡼ե饰
	unset($sqlval['session']);		    // å
	
	// ʸơ:̵꤬пդ
	if($sqlval["status"] == ""){
		$sqlval['status'] = '1';			
	}
	
	// ̤ΤϤꤷƤʤ硢Ͽ򥳥ԡ롣
	if($arrData["deliv_check"] == "-1") {
		$sqlval['deliv_name01'] = $arrData['order_name01'];
		$sqlval['deliv_name02'] = $arrData['order_name02'];
		$sqlval['deliv_kana01'] = $arrData['order_kana01'];
		$sqlval['deliv_kana02'] = $arrData['order_kana02'];
		$sqlval['deliv_pref'] = $arrData['order_pref'];
		$sqlval['deliv_zip01'] = $arrData['order_zip01'];
		$sqlval['deliv_zip02'] = $arrData['order_zip02'];
		$sqlval['deliv_addr01'] = $arrData['order_addr01'];
		$sqlval['deliv_addr02'] = $arrData['order_addr02'];
		$sqlval['deliv_tel01'] = $arrData['order_tel01'];
		$sqlval['deliv_tel02'] = $arrData['order_tel02'];
		$sqlval['deliv_tel03'] = $arrData['order_tel03'];
	}
	
	$order_id = $arrData['order_id'];		// ID
	$sqlval['create_date'] = 'now()';		// 
	
	// ڡID
	if($objCampaignSess->getIsCampaign()) $sqlval['campaign_id'] = $objCampaignSess->getCampaignId();

	// åȤͤ򥤥󥵡
	//$sqlval = lfGetInsParam($sqlval);
	
	// INSERTμ¹
	$objQuery->insert("dtb_order", $sqlval);
	
	return $order_id;
}

// ܺ٥ơ֥Ͽ
function lfRegistOrderDetail($objQuery, $order_id, $objCartSess) {
	// μ
	$arrCart = $objCartSess->getCartList();
	$max = count($arrCart);
	
	// ¸ߤܺ٥쥳ɤäƤ
	$objQuery->delete("dtb_order_detail", "order_id = $order_id");

	// ̾
	$arrClassName = sfGetIDValueList("dtb_class", "class_id", "name");
	// ʬ̾
	$arrClassCatName = sfGetIDValueList("dtb_classcategory", "classcategory_id", "name");
			
	for ($i = 0; $i < $max; $i++) {
		// ʵʾμ	
		$arrData = sfGetProductsClass($arrCart[$i]['id']);
		
		// ¸ߤ뾦ʤΤɽ롣
		if($arrData != "") {
			$sqlval['order_id'] = $order_id;
			$sqlval['product_id'] = $arrCart[$i]['id'][0];
			$sqlval['classcategory_id1'] = $arrCart[$i]['id'][1];
			$sqlval['classcategory_id2'] = $arrCart[$i]['id'][2];
			$sqlval['product_name'] = $arrData['name'];
			$sqlval['product_code'] = $arrData['product_code'];
			$sqlval['classcategory_name1'] = $arrClassCatName[$arrData['classcategory_id1']];
			$sqlval['classcategory_name2'] = $arrClassCatName[$arrData['classcategory_id2']];
			$sqlval['point_rate'] = $arrCart[$i]['point_rate'];			
			$sqlval['price'] = $arrCart[$i]['price'];
			$sqlval['quantity'] = $arrCart[$i]['quantity'];
			lfReduceStock($objQuery, $arrCart[$i]['id'], $arrCart[$i]['quantity']);
			// INSERTμ¹
			$objQuery->insert("dtb_order_detail", $sqlval);
		} else {
			sfDispSiteError(CART_NOT_FOUND);
		}
	}
}

/* ơ֥κ */
function lfDeleteTempOrder($objQuery, $uniqid) {
	$where = "order_temp_id = ?";
	$sqlval['del_flg'] = 1;
	$objQuery->update("dtb_order_temp", $sqlval, $where, array($uniqid));
	// $objQuery->delete("dtb_order_temp", $where, array($uniqid));
}

// ڡơ֥Ͽ
function lfRegistCampaignOrder($objQuery, $objCampaignSess, $order_id) {

	// ǡ
	$cols = "order_id, campaign_id, customer_id, message, order_name01, order_name02,".
			"order_kana01, order_kana02, order_email, order_tel01, order_tel02, order_tel03,".
			"order_fax01, order_fax02, order_fax03, order_zip01, order_zip02, order_pref, order_addr01,".
			"order_addr02, order_sex, order_birth, order_job, deliv_name01, deliv_name02, deliv_kana01,".
			"deliv_kana02, deliv_tel01, deliv_tel02, deliv_tel03, deliv_fax01, deliv_fax02, deliv_fax03,".
			"deliv_zip01, deliv_zip02, deliv_pref, deliv_addr01, deliv_addr02, payment_total";

	$arrOrder = $objQuery->select($cols, "dtb_order", "order_id = ?", array($order_id)); 
			
	$sqlval = $arrOrder[0];
    $sqlval['create_date'] = 'now()';
		
	// INSERTμ¹
	$objQuery->insert("dtb_campaign_order", $sqlval);
	
	// ߿ι
	$total_count = $objQuery->get("dtb_campaign", "total_count", "campaign_id = ?", array($sqlval['campaign_id']));
	$arrCampaign['total_count'] = $total_count += 1;
	$objQuery->update("dtb_campaign", $arrCampaign, "campaign_id = ?", array($sqlval['campaign_id']));
	
}

// ߸ˤ򸺤餹
function lfReduceStock($objQuery, $arrID, $quantity) {
	$where = "product_id = ? AND classcategory_id1 = ? AND classcategory_id2 = ?";
	$arrRet = $objQuery->select("stock, stock_unlimited", "dtb_products_class", $where, $arrID);
	
	// ڤ쥨顼
	if(($arrRet[0]['stock_unlimited'] != '1' && $arrRet[0]['stock'] < $quantity) || $quantity == 0) {
		$objQuery->rollback();
		sfDispSiteError(SOLD_OUT, "", true);
	// ̵¤ξ硢߸ˤNULL
	} elseif($arrRet[0]['stock_unlimited'] == '1') {
		$sqlval['stock'] = null;
		$objQuery->update("dtb_products_class", $sqlval, $where, $arrID);
	// ߸ˤ򸺤餹
	} else {
		$sqlval['stock'] = ($arrRet[0]['stock'] - $quantity);
		if($sqlval['stock'] == "") {
			$sqlval['stock'] = '0';
		}		
		$objQuery->update("dtb_products_class", $sqlval, $where, $arrID);
	}
}

?>