<?php
/*
 * Copyright(c) 2000-2007 LOCKON CO.,LTD. All Rights Reserved.
 *
 * http://www.lockon.co.jp/
 */
require_once(MODULE_PATH . "mdl_paygent/mdl_paygent.inc");

class LC_Page {
	function LC_Page() {
		/** ɬꤹ **/
		if (GC_MobileUserAgent::isMobile()) {
			$this->tpl_mainpage = MODULE_PATH . "mdl_paygent/paygent_credit_mobile.tpl";
		} else {
			$this->tpl_mainpage = MODULE_PATH . "mdl_paygent/paygent_credit.tpl";
		}
		/*
		 session_startno-cacheإå뤳Ȥ
		 ץܥѻͭڤɽ롣
		 private-no-expire:饤ȤΥåĤ롣
		*/
		session_cache_limiter('private-no-expire');		
	}
}

$objPage = new LC_Page();
if (GC_MobileUserAgent::isMobile()) {
	$objView = new SC_MobileView();
} else {
	$objView = new SC_SiteView();
}
$objCampaignSess = new SC_CampaignSession();
$objSiteInfo = $objView->objSiteInfo;
$arrInfo = $objSiteInfo->data;

// ѥ᡼饹
$objFormParam = new SC_FormParam();
// ѥ᡼ν
lfInitParam();
// POSTͤμ
$objFormParam->setParam($_POST);

// Ƚ׽
$objPage = sfTotalCart($objPage, $objCartSess, $arrInfo);

// ơ֥ɹ
$arrData = sfGetOrderTemp($uniqid);

// Ƚפ򸵤˺ǽ׻
$arrData = sfTotalConfirm($arrData, $objPage, $objCartSess, $arrInfo);

switch($_POST['mode']) {
// Υڡ
case 'return':
	// ʿܤǤ뤳ȤϿƤ
	$objSiteSess->setRegistFlag();
	if (GC_MobileUserAgent::isMobile()) {
		header("Location: " . gfAddSessionId(MOBILE_URL_SHOP_CONFIRM));
	} else {
		header("Location: " . URL_SHOP_CONFIRM);
	}
	break;
// 
case 'next':
	// ͤѴ
	$objFormParam->convParam();
	$objPage->arrErr = lfCheckError($arrRet);
	// ϥ顼ʤξ
	if(count($objPage->arrErr) == 0) {
		 // ϥǡμԤ
    	$arrInput = $objFormParam->getHashArray();
		// 쥸åʸ
		$arrRet = sfSendPaygentCredit($arrData, $arrInput, $uniqid);
		
		// 3D奢̤б
		if ($arrRet['result'] === "0") {
            // Ͽ줿ȤϿ
            $objSiteSess->setRegistFlag();
			if (GC_MobileUserAgent::isMobile()) {
				header("Location: ". gfAddSessionId(MOBILE_URL_SHOP_COMPLETE));
			} else {
				header("Location: ". URL_SHOP_COMPLETE);
			}
		// 3D奢б
		} elseif ($arrRet['result'] === "7") {
			// ɲҲ̤ܡACSʧǧ׵HTMLɽ
			print mb_convert_encoding($arrRet['out_acs_html'], CHAR_CODE, "Shift-JIS");
			exit;
		// 
		} else {
			$objPage->tpl_error = "ǧڤ˼ԤޤǤƤ򤴳ǧ";
		}
	}
	break;
}

// 3D奢»ܸ
if ($_GET['mode'] == "credit_3d" && $_GET['uniqid'] == $uniqid) {
	// 쥸åʸ3D奢»ܸ
	$arrRet = sfSendPaygetnCredit3d($arrData, $_POST, $uniqid);
	// 
	if ($arrRet['result'] === "0") {
		// Ͽ줿ȤϿ
		$objSiteSess->setRegistFlag();
		header("Location: ". URL_SHOP_COMPLETE);
	}
}

$objDate = new SC_Date();
$objDate->setStartYear(RELEASE_YEAR);
$objDate->setEndYear(RELEASE_YEAR + CREDIT_ADD_YEAR);
$objPage->arrYear = $objDate->getZeroYear();
$objPage->arrMonth = $objDate->getZeroMonth();

// ̤ɽ
$objPage = sfPaygentDisp($objPage, $payment_id);

// ʧ
$objPage->arrPaymentClass = $arrPaymentClass;
$objPage->arrForm = $objFormParam->getFormParamList();
$objView->assignobj($objPage);
// ե졼(ڡڡܤʤѹ)
$objCampaignSess->pageView($objView);

//-------------------------------------------------------------------------------------------------------

/* ѥ᡼ν */
function lfInitParam() {
	global $objFormParam;
	$objFormParam->addParam("ʧ", "payment_class", INT_LEN, "n", array("EXIST_CHECK", "MAX_LENGTH_CHECK"));
	$objFormParam->addParam("ֹ1", "card_no01", CREDIT_NO_LEN, "n", array("EXIST_CHECK", "MAX_LENGTH_CHECK", "NUM_CHECK"));
	$objFormParam->addParam("ֹ2", "card_no02", CREDIT_NO_LEN, "n", array("EXIST_CHECK", "MAX_LENGTH_CHECK", "NUM_CHECK"));
	$objFormParam->addParam("ֹ3", "card_no03", CREDIT_NO_LEN, "n", array("EXIST_CHECK", "MAX_LENGTH_CHECK", "NUM_CHECK"));
	$objFormParam->addParam("ֹ4", "card_no04", CREDIT_NO_LEN, "n", array("EXIST_CHECK", "MAX_LENGTH_CHECK", "NUM_CHECK"));
	$objFormParam->addParam("ɴǯ", "card_year", 2, "n", array("EXIST_CHECK", "NUM_COUNT_CHECK", "NUM_CHECK"));
	$objFormParam->addParam("ɴ·", "card_month", 2, "n", array("EXIST_CHECK", "NUM_COUNT_CHECK", "NUM_CHECK"));
	$objFormParam->addParam("", "card_name01", STEXT_LEN, "KVa", array("EXIST_CHECK", "MAX_LENGTH_CHECK", "ALPHA_CHECK"));
	$objFormParam->addParam("̾", "card_name02", STEXT_LEN, "KVa", array("EXIST_CHECK", "MAX_LENGTH_CHECK", "ALPHA_CHECK"));
}

/* ƤΥå */
function lfCheckError() {
	global $objFormParam;
	// ϥǡϤ
	$arrRet =  $objFormParam->getHashArray();
	$objErr = new SC_CheckError($arrRet);
	$objErr->arrErr = $objFormParam->checkError();
	
	return $objErr->arrErr;
}
?>